<?php

define(LIB_DIR, dirname(__FILE__).DIRECTORY_SEPARATOR."lib".DIRECTORY_SEPARATOR);
define(CACHE_DIR, dirname(__FILE__).DIRECTORY_SEPARATOR."cache".DIRECTORY_SEPARATOR);
define(TS_URL, "http://ssl2.gcrest.com");
define(CACHE_AVALABLE, 900);//15 minutes
define(TOPIC_NUM, 20);

if (!is_dir(CACHE_DIR))
	mkdir(CACHE_DIR);

mb_internal_encoding("UTF-8");
header("Content-type: application/xml; charset = UTF-8");
header("Content-Langage: ja");

if ($_GET['page'] == "mente_info")
	$url = TS_URL."/trickster/update/information/maintenance/for_window_loggedIn.html";
else if ($_GET['page'] == "news")
	$url = TS_URL."/trickster/update/information/news/gcrest/for_window_loggedIn.html";
else if ($_GET['page'] == "event")
	$url = TS_URL."/trickster/update/information/event/gcrest/for_window_loggedIn.html";
else
	exit(1);

$cache_name = CACHE_DIR.$_GET['page'].".xml";

if (file_exists($cache_name))
{
	if (time() - filemtime($cache_name) < CACHE_AVALABLE)
	{
		echo file_get_contents($cache_name);
		exit;
	}
}
if ($xml = make_cache($url, $cache_name))
	echo $xml;

function make_cache($url, $cache_name)
{
	require_once(LIB_DIR."Snoopy.class.php");
	$snoopy = new Snoopy;

	if ($snoopy->fetch($url))
	{
		preg_match("|<title>(.*)</title>|", $snoopy->results, $title);
		preg_match_all("|<p class=\"lead\"><a href=\"([^\"]*)\"[^>]*>(.*)</a></p>\s*<p class=\"date\">(.*)</p>|", $snoopy->results, $data);
		
		$xml = '<?xml version="1.0" encoding="utf-8" ?><rss version="2.0"><channel><title>'.$title[1].'</title><link>'.$url.'</link><language>ja</language><category>Weblog</category><doc>http://backend.userland.com/rss</doc>';

		for($i = 0; $i < count($data[1]); $i++)
		{
			if ($i == TOPIC_NUM)
				break;
						
			$d = explode('/', $data[3][$i]);
			$date = date("r", mktime(0, 0, 0, $d[1], $d[2], $d[0]));
			$xml .= "<item><title>".$data[2][$i]."</title><link>".TS_URL.$data[1][$i]."</link><pubDate>".$date."</pubDate></item>";
		}
		
		$xml .= '</channel></rss>';
		
		$file = fopen($cache_name, "w");
		fwrite($file, $xml);
		fclose($file);
		
		return $xml;
	}
	return false;
}

?>